<template>
    <div class="field-select">
        <div :class="['field-select__active-item', showList ? 'field-select__active-item--active' : '']" @click="showList = !showList">
            <span :class="[{'field-select__dummy-text': !value}]">{{ selectedItem }}</span>
        </div>
        <div v-show="showList" :class="['field-select__list-items']">
            <modal-list-items @selected="selectItem" :list="listItems" :positions="{ right: '-12px', top: 0 }" />
        </div>
        <transition name="slide">
            <div v-show="error && !value"
            >
                <div class="error-message field-select__error-message">
                    {{ error }}
                </div>
            </div>
        </transition>
    </div>
</template>

<script>

export default {
    name: 'base-field-select',
    components: {
        ModalListItems: () => import('components/ModalListItems.vue')
    },
    props: {
        list: {
            type: Array,
            required: true
        },
        dummy: {
            type: [String, Number],
            default: ''
        },
        value: {
            type: [String, Number]
        },
        error: String
    },
    data() {
        return {
            index: 0,
            selectedItem: this.value,
            showList: false,
            listItems: []
        };
    },
    watch: {
        value(val) {
            const currentItemIndex = this.listItems.findIndex(item => item === val);

            if (!val) {
                this.index = 0;
                this.selectedItem = this.dummy && !val ? this.dummy : this.listItems[this.index];
            } else if (val && currentItemIndex !== -1) {
                this.index = currentItemIndex;
                this.selectedItem = this.listItems[currentItemIndex];
            }
        }
    },
    created() {
        this.listItems = this.list.slice();

        if (this.value) {
            const index = this.listItems.findIndex(item => item.toString().toLowerCase() === this.value.toString().toLowerCase());
            this.index = index !== -1 ? index : 0;
        }

        this.selectedItem = this.dummy && !this.value ? this.dummy : this.listItems[this.index];
    },
    methods: {
        selectItem(value) {
            if (value.toString() !== this.selectedItem.toString()) {
                this.index = this.listItems.findIndex(item => item.toString() === value.toString());
                this.selectedItem = this.listItems[this.index];
                this.$emit('input', value !== this.dummy ? this.selectedItem : '');
            }
            this.showList = false;
        }
    }
};
</script>

<style lang="sass">
@import "~assets/blocks/fields/field-select/index"
</style>
